import { defineComponent } from 'vue';
import styles from './index.module.less';
import popBox from './select_courseware_box.png';
import popClose from './selce_courseware_close.png';
import popTitle from './select_courseware_title.png';
import iconCancel from './select_courseware_cancel.png';
import iconChange from './select_courseware_change.png';

export default defineComponent({
  name: 'SelectCoursewarePop',
  props: {
    message: {
      type: String,
      default: '当前是课件最后一个资源，是否切换下一个课件？'
    }
  },
  emits: ['close', 'confirm'],
  setup(props, { emit }) {
    return () => (
      <div
        class={styles.popBox}
        onClick={(e: Event) => e.stopPropagation()}
        onTouchmove={(e: TouchEvent) => e.stopPropagation()}>
        <div class={styles.popBody}>
          <img class={styles.popBg} src={popBox} />
          <img
            class={styles.popClose}
            src={popClose}
            onClick={(e: Event) => {
              emit("close");
            }}
          />

          <img class={styles.popTitle} src={popTitle} />
          <div class={styles.list} id="list">
            {props.message}
          </div>
          <div class={styles.btnGroup}>
            <img
              class={styles.btn}
              src={iconCancel}
              onClick={() => {
                emit('close');
              }}
            />
            <img
              class={styles.btn}
              src={iconChange}
              onClick={() => {
                emit('confirm');
              }}
            />
          </div>
        </div>
      </div>
    );
  }
});
